﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Convert2Bin {
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {
        public MainWindow() {
            InitializeComponent();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            String sNumber = tNumber.Text.Trim();
            if (sNumber.Length > 0) {
                ConvertNumber(sNumber);
            }
        }

      private String base_convert1(int number,int basis){ 
       char[] hex={'0','1','2','3','4','5','6','7','8','9', 'A','B','C','D','E','F','G','H','I','J',
                'K','L','M','N','O','P','Q','R','S','T',  'U','V','W','X','Y','Z',
				    'a','b','c','d','e','f','g','h','i','j', 'k','l','m','n','o','p','q','r','s','t',
                'u','v','w','x','y','z' };
       String erg="";
       int zahl=number;
       int rest;
       while (zahl>0) {
           rest = zahl % basis;
          erg=hex[rest]+erg;
          zahl = zahl / basis;
        }
       if ( erg.Length <2) erg="0"+erg;
       return  erg;
      }

      private String base_convert2(String sNumber, int number, int basis) {
          StringBuilder erg = new StringBuilder();
          StringBuilder erg2 = new StringBuilder();
          int zahl = number;
          int l2;
          int n = 0;
          String s = sNumber;
          while (s.EndsWith("0")) {
              s = s.Remove(s.Length - 1);
          }
          int l1 = s.Length;
          int grenze = 1;
          for (int i = 0; i < l1; i++) {
              grenze *= 10;
          }
          while (zahl > 0 && n < 30) {
              int zahlOri = zahl;
              zahl = zahl * basis;  // 0,75 *2  = 150   
              if (zahl>=grenze) {
                  erg.Append("1");
                  erg2.AppendLine("0," + zahlOri + " * " + basis + "\t=\t1," + zahl.ToString().Substring(1)  + "\t\t1");
                  zahl -= grenze;
              }
              else {
                  erg.Append("0");
                  erg2.AppendLine("0," + zahlOri + " * " + basis + "\t=\t0," + zahl + "\t\t0");
              }
              n++;
              if (n%4==0)erg.Append(" ");
          }
          return erg.ToString() + "\r\n\r\n\r\n" + erg2.ToString();
      }

        private void ConvertNumber(String sNumber) {
            String main, komma;
            String erg1="", erg2="";
            String erg="";
            sNumber = sNumber.Replace(',', '.');
            int index = sNumber.IndexOf('.');
            int number;
            main = sNumber;
            if (index >= 0) {
                main = sNumber.Substring(0, index);
                komma = sNumber.Substring(index+1);
                if (int.TryParse(komma, out number)) {
                    erg2 = base_convert2(komma, number, 2);
                }
            }
            if (int.TryParse(main, out number)) {
                erg1 = base_convert1(number, 2);
            }

            if (erg2.Length>0)
                tErg.Text = erg1+" . "+erg2;
            else
                tErg.Text = erg1;


        }
    }
}
